پساز تکمیل مراحل در آماده شدن برای استفاده از People API، آماده خواندن، کپی کردن، و جستجوی دادههای «مخاطبین دیگر» هستید.
نمونه کدهای زیر نحوه ارسال چند درخواست ساده را نشان میدهند. برای مشاهده فهرست کامل روشها، به اسناد مرجع مراجعه کنید.
فهرست کردن «مخاطبین دیگر» کاربر
برای دریافت فهرستی از افراد در «مخاطبین دیگر» کاربر، از کد زیر استفاده کنید:
پروتکل
GET /v1/otherContacts?readMask=names,emailAddresses HTTP/1.1 Host: people.googleapis.com
جاوا
ListOtherContactsResponse response = peopleService.otherContacts().list() .setReadMask("metadata,names,emailAddresses") .execute(); List<Person> otherContacts = response.getOtherContacts();
فهرست کردن «مخاطبین دیگر» کاربر که تغییر کردهاند
جاوا
// Initial request ListOtherContactsResponse fullSyncResponse = peopleService.otherContacts().list() .setReadMask("metadata,names,emailAddresses") .setRequestSyncToken(true) .execute(); // Fetch all the pages while (fullSyncResponse.getNextPageToken() != null) { fullSyncResponse = peopleService.otherContacts().list() .setReadMask("metadata,names,emailAddresses") .setRequestSyncToken(true) .setPageToken(fullSyncResponse.getNextPageToken()) .execute(); } // Some time passes // Fetch incremental changes using the sync token returned in the last fullSyncResponse. try { ListOtherContactsResponse incrementalSyncResponse = peopleService.otherContacts().list() .setReadMask("metadata,names,emailAddresses") .setSyncToken(fullSyncResponse.getNextSyncToken()) .execute(); for (Person person : incrementalSyncResponse.getOtherContacts()) { handlePerson(person); } // Fetch all the pages while (!incrementalSyncResponse.getNextPageToken().isEmpty()) { incrementalSyncResponse = peopleService.otherContacts().list() .setReadMask("metadata,names,emailAddresses") .setSyncToken(fullSyncResponse.getNextSyncToken()) .setPageToken(incrementalSyncResponse.getNextPageToken()) .execute(); for (Person person : incrementalSyncResponse.getOtherContacts()) { handlePerson(person); } } } catch (GoogleJsonResponseException e) { if (e.getStatusCode() == 410) { // Sync token expired. Make full sync request. } } void handlePerson(Person person) { if (person.getMetadata().getDeleted()) { // Handle deleted person } else { // Handle changed person } }
جزئیات بیشتر درباره رفتار همگامسازی در ListOtherContacts.
کپی کردن «مخاطب دیگر» در گروه «مخاطبین من»
برای کپی کردن «مخاطب دیگر» در گروه «مخاطبین من»، از کد زیر استفاده کنید:
پروتکل
POST /v1/resource_name:copyOtherContactToMyContactsGroup?copyMask=names,emailAddresses,phoneNumbers HTTP/1.1 Host: people.googleapis.com
جاوا
Person copiedContact = peopleService .otherContacts() .copyOtherContactToMyContactsGroup( "resource_name", new CopyOtherContactToMyContactsGroupRequest() .setCopyMask("names,emailAddresses,phoneNumbers")) .execute();
جستجوی «مخاطبین دیگر» کاربر
برای جستجوی همه «مخاطبین دیگر» کاربر، از کد زیر استفاده کنید:
پروتکل
// Warmup cache GET /v1/otherContacts:search?query=&readMask=names,emailAddresses HTTP/1.1 Host: people.googleapis.com // Send search request after several seconds GET /v1/otherContacts:search?query=query&readMask=names,emailAddresses HTTP/1.1 Host: people.googleapis.com
جاوا
// Warmup cache SearchResponse response = peopleService.otherContacts().search() .setQuery("") .setReadMask("names,emailAddresses") .execute(); // Wait a few seconds Thread.sleep(5); // Send search request SearchResponse response = peopleService.otherContacts().search() .setQuery("query") .setReadMask("names,emailAddresses") .execute();